#include <stdio.h>
#include <stdlib.h>
#include <an.h>
#define BHIGH 255
#define BLOW  0

int main( argc, argv )
	int argc ;
	char **argv ;
{
	AN_IMAGE_COORD img ;
	double *u=NULL, *v=NULL ;
	unsigned char *b=NULL ;
	int ret ;
	FILE *fpu=NULL, *fpv=NULL, *fpb=NULL ;

	if ( argc!= 4 ) {
		fputs( "usage: comp file.u file.v file.b\n", stderr ) ;
		ret = -1 ;
	} else if ( an_get_img( &img ) == -1 ) {
		fputs( "error: cannot find image environment\n", stderr ) ;
		ret = -1 ;
	} else if (	(u=(double *)malloc(img.x*sizeof*u))==NULL ||
			(v=(double *)malloc(img.x*sizeof*v))==NULL ||
			(b=(unsigned char *)malloc(img.x*sizeof*b))==NULL ) {
		fputs( "error: cannot allocate memory\n", stderr ) ;
		ret = -1 ;
	} else if (	(fpu=fopen(argv[1],"rb"))==NULL ||
			(fpv=fopen(argv[2],"rb"))==NULL ||
			(fpb=fopen(argv[3],"wb"))==NULL ) {
		fputs( "error: cannot read or create file\n", stderr ) ;
		ret = -2 ;
	} else {
		int t, y, x ;

		for ( t=0; t<img.t; ++t )
		for ( y=0; y<img.y; ++y ) {
			fread( u, sizeof*u, img.x, fpu ) ;
			fread( v, sizeof*v, img.x, fpv ) ;

			for ( x=0; x<img.x; ++x )
				if ( u[x]>v[x] )
					b[x] = BHIGH ;
				else
					b[x] = BLOW ;

			fwrite( b, sizeof*b, img.x, fpb ) ;
		}

		ret = 0 ;
	}

	free( u ) ;
	free( v ) ;
	free( b ) ;
	fclose( fpu ) ;
	fclose( fpv ) ;

	return ret ;
}

