/*
	t2d: generating Turing pattern in 2-D
*/

#define STR_LEN	512

typedef struct PARAMS {
	char *para_file, *result_file ;

	int dx, dy, dt ;
	int lx, ly, lt ; /* lx,ly: image size */

	int loop ;	/* loop number for solving simultaneous equations */
	int tintv ;	/* time interval for displaying the result */
	double r ;	/* r=0.5:Crank-Nicolson, r=1.0:full implicit */
	double delta ;

	char fnu[STR_LEN] ; /* file name of image data */

	double Du, Dv, a, b, gamma, var_min, var_max ;
	double Cux, Cuy, Cvx, Cvy ;
	double norm ;	/* normalization parameter */
} PARAMS ;

